/*
Copyright Kumori.

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by client-gen. DO NOT EDIT.

package fake

import (
	getambassadoriov1 "gitlab.com/mandanga-public/sub1/sub2/client-go/pkg/apis_ambassador/getambassador.io/v1"
	v1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	labels "k8s.io/apimachinery/pkg/labels"
	schema "k8s.io/apimachinery/pkg/runtime/schema"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	testing "k8s.io/client-go/testing"
)

// FakeKubernetesEndpointResolvers implements KubernetesEndpointResolverInterface
type FakeKubernetesEndpointResolvers struct {
	Fake *FakeGetambassadorV1
	ns   string
}

var kubernetesendpointresolversResource = schema.GroupVersionResource{Group: "getambassador.io", Version: "v1", Resource: "kubernetesendpointresolvers"}

var kubernetesendpointresolversKind = schema.GroupVersionKind{Group: "getambassador.io", Version: "v1", Kind: "KubernetesEndpointResolver"}

// Get takes name of the kubernetesEndpointResolver, and returns the corresponding kubernetesEndpointResolver object, and an error if there is any.
func (c *FakeKubernetesEndpointResolvers) Get(name string, options v1.GetOptions) (result *getambassadoriov1.KubernetesEndpointResolver, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewGetAction(kubernetesendpointresolversResource, c.ns, name), &getambassadoriov1.KubernetesEndpointResolver{})

	if obj == nil {
		return nil, err
	}
	return obj.(*getambassadoriov1.KubernetesEndpointResolver), err
}

// List takes label and field selectors, and returns the list of KubernetesEndpointResolvers that match those selectors.
func (c *FakeKubernetesEndpointResolvers) List(opts v1.ListOptions) (result *getambassadoriov1.KubernetesEndpointResolverList, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewListAction(kubernetesendpointresolversResource, kubernetesendpointresolversKind, c.ns, opts), &getambassadoriov1.KubernetesEndpointResolverList{})

	if obj == nil {
		return nil, err
	}

	label, _, _ := testing.ExtractFromListOptions(opts)
	if label == nil {
		label = labels.Everything()
	}
	list := &getambassadoriov1.KubernetesEndpointResolverList{ListMeta: obj.(*getambassadoriov1.KubernetesEndpointResolverList).ListMeta}
	for _, item := range obj.(*getambassadoriov1.KubernetesEndpointResolverList).Items {
		if label.Matches(labels.Set(item.Labels)) {
			list.Items = append(list.Items, item)
		}
	}
	return list, err
}

// Watch returns a watch.Interface that watches the requested kubernetesEndpointResolvers.
func (c *FakeKubernetesEndpointResolvers) Watch(opts v1.ListOptions) (watch.Interface, error) {
	return c.Fake.
		InvokesWatch(testing.NewWatchAction(kubernetesendpointresolversResource, c.ns, opts))

}

// Create takes the representation of a kubernetesEndpointResolver and creates it.  Returns the server's representation of the kubernetesEndpointResolver, and an error, if there is any.
func (c *FakeKubernetesEndpointResolvers) Create(kubernetesEndpointResolver *getambassadoriov1.KubernetesEndpointResolver) (result *getambassadoriov1.KubernetesEndpointResolver, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewCreateAction(kubernetesendpointresolversResource, c.ns, kubernetesEndpointResolver), &getambassadoriov1.KubernetesEndpointResolver{})

	if obj == nil {
		return nil, err
	}
	return obj.(*getambassadoriov1.KubernetesEndpointResolver), err
}

// Update takes the representation of a kubernetesEndpointResolver and updates it. Returns the server's representation of the kubernetesEndpointResolver, and an error, if there is any.
func (c *FakeKubernetesEndpointResolvers) Update(kubernetesEndpointResolver *getambassadoriov1.KubernetesEndpointResolver) (result *getambassadoriov1.KubernetesEndpointResolver, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewUpdateAction(kubernetesendpointresolversResource, c.ns, kubernetesEndpointResolver), &getambassadoriov1.KubernetesEndpointResolver{})

	if obj == nil {
		return nil, err
	}
	return obj.(*getambassadoriov1.KubernetesEndpointResolver), err
}

// Delete takes name of the kubernetesEndpointResolver and deletes it. Returns an error if one occurs.
func (c *FakeKubernetesEndpointResolvers) Delete(name string, options *v1.DeleteOptions) error {
	_, err := c.Fake.
		Invokes(testing.NewDeleteAction(kubernetesendpointresolversResource, c.ns, name), &getambassadoriov1.KubernetesEndpointResolver{})

	return err
}

// DeleteCollection deletes a collection of objects.
func (c *FakeKubernetesEndpointResolvers) DeleteCollection(options *v1.DeleteOptions, listOptions v1.ListOptions) error {
	action := testing.NewDeleteCollectionAction(kubernetesendpointresolversResource, c.ns, listOptions)

	_, err := c.Fake.Invokes(action, &getambassadoriov1.KubernetesEndpointResolverList{})
	return err
}

// Patch applies the patch and returns the patched kubernetesEndpointResolver.
func (c *FakeKubernetesEndpointResolvers) Patch(name string, pt types.PatchType, data []byte, subresources ...string) (result *getambassadoriov1.KubernetesEndpointResolver, err error) {
	obj, err := c.Fake.
		Invokes(testing.NewPatchSubresourceAction(kubernetesendpointresolversResource, c.ns, name, pt, data, subresources...), &getambassadoriov1.KubernetesEndpointResolver{})

	if obj == nil {
		return nil, err
	}
	return obj.(*getambassadoriov1.KubernetesEndpointResolver), err
}
